#ifndef ALGORITMUS_H_INCLUDED
#define ALGORITMUS_H_INCLUDED
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#define KONIEC printf("\n\nF I N I T O !\n\n");system("pause");exit(0);

/**
* vytvori dynamicky 2D pole
* @param pocet riadkov
* @param pocet stlpcov
* @return 2D pole int
*/
int **vytvor_pole(int riadky, int stlpce);

/**
* uvolni 2D pole
* @param 2D pole int
* @param pocet riadkov
*/
void uvolni_pole(int **p_p_x, int riadky);

/**
* vyhodnotenie vstupu uzivatela, ulozi do pole zadane hodnoty
* @param pole int
*/
void vyhodnot(int h[]);

/**
* zisti vsetky cisla kombinacie a vypise ich od najmensieho
* @param 2D pole int (generovane kombinacie)
* @param pocet miest
* @param pocet farieb
*/
void zisti_cisla(int **g, int m, int f);

/**
* prehadzuje jednotlive farby az do zdarneho konca
* @param 2D pole int (generovane kombinacie)
* @param pole na kombinaciu
* @param pole na vyhodnotenie
* @param pocet miest
* @param pocet farieb
*/
void dorovnaj(int **g, int prv[], int h[], int m, int f);

/**
* zisti, ci kombinacia uz nebola pouzita
* @param 2D pole int (generovane kombinacie)
* @param pole na kombinaciu
* @param pocet miest
* @param posledny index 2D pola
*/
bool pouzite(int **g, int prv[], int m, int por);

/**
* prehodi navzajom dve cisla na zaklade indexov
* @param pole na kombinaciu
* @param pocet miest
* @param a index v poli
* @param b index v poli
*/
void prehod_dve_cisla(int komb[], int m, int a, int b);

/**
* vypise generovanu kombinaciu
* @param pole na kombinaciu
* @param pocet miest
*/
void vypis(int komb[], int m);

#endif // ALGORITMUS_H_INCLUDED
